﻿
using System.Collections.Concurrent;
using System.Collections.Generic;
using Ozeki.VoIP;
namespace SIPGateway
{
    /// <summary>
    /// SIP account container class.
    /// </summary>
    class SIPAccountPool
    {

        Queue<SIPAccount> sipAccounts;
        
        /// <summary>
        /// Create a new instace of SIPAccountPool.
        /// </summary>
        public SIPAccountPool()
        {
            sipAccounts = new Queue<SIPAccount>();
        }

        /// <summary>
        /// Gets the next free SIP account.
        /// </summary>
        /// <returns></returns>
        public SIPAccount GetSIPAccount()
        {
            SIPAccount sipAccount;
            lock (sipAccounts)
            {
                if (sipAccounts.Count > 0)
                {
                    sipAccount = sipAccounts.Dequeue();
                    return sipAccount;
                }
            }
            return null;
        }

        /// <summary>
        /// Adds a SIP account to the accounts queue.
        /// </summary>
        /// <param name="sipAccount"></param>
        public void AddSIPAcount(SIPAccount sipAccount)
        {
            lock (sipAccounts)
            {
                sipAccounts.Enqueue(sipAccount);    
            }
            
        }
    }
}
